.586
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib

DialogProc      PROTO   :DWORD,:DWORD,:DWORD,:DWORD
ConvertToASCII  PROTO   :DWORD,:DWORD

.const  

NoButtons       equ     2

.data

hInstance       dd              ?
DlgName         db             'DialogProcesses',0

hToolbar        dd              ?
TBButtons       TBBUTTON        <0,1,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                     TBBUTTON        <1,2,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                     
hTreeView       dd              ?
tvis            TV_INSERTSTRUCT <>
tvi                     TV_ITEM         <>

hListbox           dd              ?

pe32    PROCESSENTRY32          <>
te32     THREADENTRY32            <>

NumBuffer       db      8 dup('0'),'H',0
xlat_table      db      '0123456789abcdef',0


.code
        start:  
                invoke  GetModuleHandle,NULL
                mov     hInstance,eax
                invoke  DialogBoxParam,hInstance,1000,NULL,addr DialogProc,NULL
                invoke  ExitProcess,eax

DialogProc      PROC    hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

        .if     uMsg==WM_INITDIALOG
                invoke  GetDlgItem,hDlg,1002
                mov     hToolbar,eax
                invoke  GetDlgItem,hDlg,1004
                mov     hListbox,eax
                invoke  GetDlgItem,hDlg,1003
                mov     hTreeView,eax
                call      DoToolbar
                call      FillControls2
        .elseif uMsg==WM_CLOSE
                invoke  EndDialog,hDlg,NULL                                
        .else
                mov     eax,FALSE
                ret
        .endif

        mov     eax,TRUE
        ret
                        
DialogProc      endp

DoToolbar       PROC    

        invoke  SendMessage,hToolbar,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,NULL
        invoke  SendMessage,hToolbar,TB_ADDBUTTONS,NoButtons,addr TBButtons
        ret

DoToolbar       endp

FillControls    PROC

        local   hSnap:DWORD

        mov     tvis.hInsertAfter,TVI_LAST
        mov     tvis.item.imask,TVIF_TEXT+TVIF_PARAM+TVIF_SELECTEDIMAGE+TVIF_IMAGE
        invoke  CreateToolhelp32Snapshot,TH32CS_SNAPMODULE+TH32CS_SNAPPROCESS,NULL
        mov     hSnap,eax
        mov     pe32.dwSize,sizeof pe32
        mov     te32.dwSize,sizeof te32
        push    offset pe32.szExeFile
        pop     tvis.item.pszText

@@1:        
        invoke  Process32First,hSnap,addr pe32
        cmp     eax,FALSE
        je        end_fc
@@2:
        push    pe32.th32ProcessID
        pop     tvis.item.lParam
        invoke  SendMessage,hTreeView,TVM_INSERTITEM,NULL,addr tvis
        invoke  Process32Next,hSnap,addr pe32
        cmp     eax,FALSE
        je      end_fc
        jmp     @@2
end_fc:
        invoke  CloseHandle,hSnap
        invoke  CreateToolhelp32Snapshot,TH32CS_SNAPTHREAD,NULL
        mov     hSnap,eax
        mov     tvi.imask,TVIF_TEXT+TVIF_PARAM+TVIF_HANDLE
        invoke  SendMessage,hTreeView,TVM_GETNEXTITEM,TVGN_ROOT,NULL    
        push    eax
        pop     tvi.hItem
        invoke  Thread32First,hSnap,addr te32
        cmp     eax,FALSE
        je      end_te
@@3:
        mov     eax,te32.th32ThreadID
        push    eax
        invoke  SendMessage,hTreeView,TVM_GETITEM,NULL,addr tvi
        cmp     eax,NULL
        je       end_te
        pop     eax
        cmp     eax,tvi.lParam
        pushf
        invoke  SendMessage,hTreeView,TVM_GETNEXTITEM,TVGN_NEXT,tvi.hItem
        mov     tvi.hItem,eax
        popf        
        jne      @@3
        invoke  ConvertToASCII,tvi.lParam,addr NumBuffer
        mov     tvi.pszText,offset NumBuffer
        push    tvi.hItem
        pop     tvis.hParent
        push    te32.th32ThreadID
        pop     tvis.item.lParam
        invoke	SendMessage,hTreeView,TVM_INSERTITEM,NULL,addr tvis
        invoke  Thread32Next,hSnap,addr te32
        cmp     eax,FALSE
        je      end_te
        jmp     @@3
end_te:                
        invoke  CloseHandle,hSnap                
        ret

FillControls    endp

FillControls2   PROC

        local   hSnap:DWORD
        
        mov     tvis.hInsertAfter,TVI_LAST
        mov     tvis.item.imask,TVIF_TEXT+TVIF_PARAM+TVIF_SELECTEDIMAGE+TVIF_IMAGE
        invoke  CreateToolhelp32Snapshot,TH32CS_SNAPMODULE+TH32CS_SNAPPROCESS,NULL
        mov     hSnap,eax
        mov     pe32.dwSize,sizeof pe32
        mov     te32.dwSize,sizeof te32
        push    offset pe32.szExeFile
        pop     tvis.item.pszText

        invoke  Process32First,hSnap,addr pe32
        cmp     eax,FALSE
        je       no_process
@@1:        
        push    offset pe32.szExeFile
        pop     tvis.item.pszText
        push    pe32.th32ProcessID
        pop     tvis.item.lParam
        invoke	SendMessage,hTreeView,TVM_INSERTITEM,NULL,addr tvis
        push    tvis.hParent
        mov     tvis.hParent,eax
        push    hSnap
        invoke  CreateToolhelp32Snapshot,TH32CS_SNAPTHREAD,pe32.th32ProcessID
        mov     hSnap,eax
        invoke  Thread32First,hSnap,addr te32
        cmp     eax,FALSE
        je      no_threads
@@2:
        invoke  ConvertToASCII,te32.th32ThreadID,addr NumBuffer
        mov     tvis.item.pszText,offset NumBuffer
        invoke  SendMessage,hTreeView,TVM_INSERTITEM,NULL,addr tvis
        invoke  Thread32Next,hSnap,addr te32
        cmp     eax,FALSE
        je      no_threads
        jmp     @@2
no_threads:
        invoke  CloseHandle,hSnap
        pop     hSnap
        pop     tvis.hParent
        invoke  Process32Next,hSnap,addr pe32
        cmp     eax,FALSE
        je        no_process
        jmp     @@1
no_process:
        invoke  CloseHandle,hSnap
        ret

FillControls2   endp
              
ConvertToASCII  PROC    val:DWORD,lpBuffer:DWORD

               push    eax
               push    ebx
               push    edx
               push    ecx                        
               pushfd  
               cld                                    
               mov     edi,lpBuffer
               push    edi
               mov      eax,'0000'
               stosd
               stosd
               pop     edi                                           
               mov     eax,val
               mov     ebx,010h                        
               add     edi,7
               std
looper:
               xor     edx,edx
               div     ebx
               cmp      eax,0
               je      end_looper
               push    eax
               push    ebx
               mov     al,dl
               lea     ebx,xlat_table
               xlat    
               stosb
               pop     ebx
               pop     eax
               jmp     looper
end_looper:
               mov     al,dl
               lea     ebx,xlat_table
               xlat
               stosb
               popfd
               pop     ecx
               pop     edx
               pop     ebx
               pop     eax                                                                                                
               ret

ConvertToASCII  endp
end     start        